#ifndef PACKAGE_H
#define PACKAGE_H

#include <list>
#include <string>

class Package{
private:
	std::string name;
	std::string version;
	std::string release;
	std::string summary;
	int license;
	std::string url;
	int size;
	int pkgsize;
	std::list<std::string> description;
	bool installed;

public:
	Package();
	Package(const Package&);
	~Package();
	
	void setname(const std::string&);
	void setversion(const std::string&);
	void setrelease(const std::string&);
	void setsummary(const std::string&);
	void setlicense(const std::string&);
	void seturl(const std::string&);
	void setsize(const int);
	void setpkgsize(const int);
	void setdescription(const std::list<std::string>&);
	void setinstalled(bool);
	
	const std::string& getname() const;
	const std::string& getversion() const;
	const std::string& getrelease() const;
	const std::string& getsummary() const;
	const std::string& getlicense() const;
	const std::string& geturl() const;
	const int getsize() const;
	const int getpkgsize() const;
	const std::list<std::string>& getdescription() const;
	bool isinstalled() const;
	
	bool operator==(const std::string&) const;
	
	static bool name_compare(const Package&, const Package&);
};

#endif // PACKAGE_H
