#ifndef PACKAGETREE_H
#define PACKAGETREE_H

#include <map>
#include <string>
#include "TreeDir.h"

class PackageTree{
private:
	TreeDir root;
	std::map<std::string, int> pkg2grp;

	void set_mapping(const std::string&, const std::string&);
	static void clear_installed_status(TreeDir&);

public:
	PackageTree();
	~PackageTree();
	
	int fillup();		// zwraca liczb dodanych pakietw
	int check_installed();
	int recheck_installed();
	
	void clear();
	TreeDir& find_group(const std::string&);
	Package& find_package(const std::string&);
	TreeDir& root_group();
};

#endif // PACKAGETREE_H
