#ifndef STRING_H
#define STRING_H

#include <string>
#include <algorithm>
#include <cctype>
#include <cstdlib>

class String{
public:

	inline static bool dash(char c)
	{
		return c=='-';
	}
	
	inline static bool not_dash(char c)
	{
		return c!='-';
	}
	
	inline static bool space(char c)
	{
		return isspace(c);
	}
	
	inline static bool not_space(char c)
	{
		return !isspace(c);
	}
	
	inline static bool bracket(char c)
	{
		return c=='(';
	}
	
	inline static bool slash(char c)
	{
		return c=='/';
	}

	inline static bool colon(char c)
	{
		return c==':';
	}

	inline static bool comma(char c)
	{
		return c==',';
	}

	template <class T>
	static void split(const std::string& s, T o)
	{
		typedef std::string::const_iterator iter;

		iter i=s.begin(), j;

		while(i!=s.end())
		{
			i=find_if(i, s.end(), not_dash);
			j=find_if(i, s.end(), dash);

			if(i!=s.end())
				*o++=std::string(i, j);
				
			i=j;
		}
	}
	
	static int extract_size(const std::string& s)
	{
		typedef std::string::const_iterator iter;

		iter i, j;

		i=find_if(s.begin(), s.end(), bracket);
		i++;
		j=find_if(i, s.end(), space);

		return atoi(std::string(i, j).c_str());
	}

	static std::string extract_error(const std::string& s)
	{
		typedef std::string::const_iterator iter;

		iter i, j;

		i=find_if(s.begin(), s.end(), colon);
		i++;

		return std::string(s.begin(), i);
	}
	
	// name moe zawiera mylniki. Licz si tylko dwa ostatnie, oddzielajce
	// name od version od release.
	template <class T>
	static void split_nvr(const std::string& s, T o)
	{
		std::string::size_type i, j;
		
		i=s.rfind('-');
		j=s.rfind('-', i-1);
		
		*o++=s.substr(0, j);
		*o++=s.substr(j+1, i-j-1);
		*o++=s.substr(i+1);
	}
	
	template <class T>
	static void ungroup(const std::string& s, T o)
	{
		typedef std::string::const_iterator iter;

		iter i=s.begin(), j;

		while(i!=s.end())
		{
			j=find_if(i, s.end(), comma);

			*o++=std::string(i, j);

			i=find_if(j+1, s.end(), not_space);
		}
	}

	static inline std::string chop(const std::string& s)
	{
		return s.substr(0, s.size()-1);
	}
};

#endif // STRING_H
