#ifndef __transaction_h
#define __transaction_h

#include <string>
#include <list>
#include "Interaction.h"

#define OP_INSTALL 1
#define OP_UNINSTALL 2

class Transaction
{
	private:
		std::list<std::string> ins;
		std::list<std::string> dep;
		std::list<std::string> rem;
		std::list<std::string> err;

		void add_install(const std::string&);
		void add_dep(const std::string&);
		void add_remove(const std::string&);
		void add_error(const std::string&);

		void check_poldek_error();
		void do_install();
		void do_uninstall();

		int command;
		bool ready;
		static std::string poldek_error;
		Interaction *working_interaction;

	public:
		Transaction();
		~Transaction();

		const std::list<std::string>& get_installs() const;
		const std::list<std::string>& get_deps() const;
		const std::list<std::string>& get_removes() const;
		const std::list<std::string>& get_errors() const;

		bool try_command(const std::string&, int);
		void doit();
		void start();
		int getc();
		std::string gets();
		bool eof();
};

#endif
