#ifndef TREEDIR_H
#define TREEDIR_H

#include <list>
#include <string>
#include "Package.h"

class TreeDir{
private:
	std::string name;

	std::list<TreeDir> dirs;
	std::list<Package> pkgs;

public:
	TreeDir();
	TreeDir(const std::string&);
	~TreeDir();
	
	void clear();
	void sort();
	
	void setname(const std::string&);
	const std::string& getname() const;
	
	TreeDir& operator+=(const TreeDir&);
	Package& operator+=(const Package&);
	bool operator==(std::string) const;
	// dodaje pakiet w odpowiednim miejscu drzewa
	const void add(const std::string&, const Package&);
	TreeDir& find_group(const std::string&);
	Package& find_package(const std::string&);
	std::list<TreeDir>& get_groups();
	std::list<Package>& get_packages();
	
	static bool name_compare(const TreeDir&, const TreeDir&);
};

#endif
